
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS开发 编辑框被系统弹出的软键盘遮挡问题 / 憋错料</title>

    <meta name="description" content="iOS开发 编辑框被系统弹出的软键盘遮挡问题 我们在开发注冊界面的时候,最后几个注冊条件经常easy被系统弹出的键盘遮挡,例如以下图: 能够看见,邮箱条件被遮挡掉了,怎么解决呢?我是通过UITextField的代理加计算偏移量: - (void)viewDidLoad { [super viewDidLoad]; // Do any additional setup after loading the view, typically from a nib. self.emailTextField.delegate = self; } - (">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS开发 编辑框被系统弹出的软键盘遮挡问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我们在开发注冊界面的时候,最后几个注冊条件经常easy被系统弹出的键盘遮挡,例如以下图:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjQxNjUzNDk3OTY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YUcxME1qQXhNekEwTVRJPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>能够看见,邮箱条件被遮挡掉了,怎么解决呢?我是通过UITextField的代理加计算偏移量:</p>
<pre>- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.

    self.emailTextField.delegate = self;

}

- (void)textFieldDidBeginEditing:(UITextField *)textField{

    //  1.取得被遮挡的邮箱的textField的frame
    CGRect frame = self.emailTextField.frame;
    //  2.计算被遮挡的textField的bottom代表的高度(Y坐标) 与 能不被键盘遮挡的最大高度(Y坐标) 的距离
    int offset = frame.origin.y + 32 - (self.view.frame.size.height - 216);

    [UIView animateWithDuration:0.3 animations:^{

        if (offset &gt; 0) {

            //  让整个view向上偏移差距
            self.view.frame = CGRectMake(0, -offset, self.view.frame.size.width, self.view.frame.size.height);
        }
    }];

}

- (void)textFieldDidEndEditing:(UITextField *)textField{

    [UIView animateWithDuration:0.3 animations:^{

        //  编辑结束后重置为原来的
        self.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    }];

}
</pre>
<p>结果图:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjQxNjU3MjA4NTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YUcxME1qQXhNekEwTVRJPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 12:52:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/2014/" title="2014">2014</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS开发 编辑框被系统弹出的软键盘遮挡问题的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz5RLJ4.html" rel="bookmark">android 弹出的软键盘遮挡住EditText文本框的解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.android 弹出的软键盘遮挡住EditText文本框的解决方案:把Activit对应的布局文件filename.xml文件里的控件用比重设置布局.(例如:android:layout_weight=&quot;31&quot;)并且尽可能把高度设置成自适应的:android:layout_height=&quot;wrap_content&quot;,也就是没有设置高度的控件可压缩度的总和,如果比软键盘的高度要大,在EditText文本输入的时候,弹出的软键盘就不会遮挡住文本输入框.2.设置默认软			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JyQ1A3.html" rel="bookmark">Android - 隐藏EditText弹出的软键盘输入&lpar;SoftInput&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				隐藏EditText弹出的软键盘输入(SoftInput) 本文地址: http://blog.csdn.net/caroline_wendy 保持界面的整洁, 可以选择在进入界面时, 隐藏EditText控件的软键盘, 在点击EditView时, 再弹出; 可以在TextView所在的Activity中, 添加一个属性: android:windowSoftInputMode=&quot;stateHidden|adjustResize&quot; 表明: 软键盘的输入模式是stateHidden(隐藏			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGegNA3.html" rel="bookmark">iOS开发- 自己主动消失的弹出框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				- (void)timerFireMethod:(NSTimer*)theTimer//弹出框 { UIAlertView *promptAlert = (UIAlertView*)[theTimer userInfo]; [promptAlert dismissWithClickedButtonIndex:0 animated:NO]; promptAlert =NULL; } - (void)showAlert:(NSString *) _message{//时间 UIAlertView *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rDeQaM.html" rel="bookmark">iOS开发&mdash;&mdash;ActionSheet的使用与弹出选择对话框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在我们的iOS开发中,常会见到如下界面的需求: . 也就是点击按钮,出现选择提示框,我们今天使用两种方式(ActionSheet和AlertController)来实现该功能.示例代码上传至: https://github.com/chenyufeng1991/iOS-ActionSheet   . [使用ActionSheet实现] (1)实现代码如下: #import &quot;ViewController.h&quot; @interface ViewController ()&lt;UIActi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz8qqd3.html" rel="bookmark">iOS开发&mdash;&mdash;UI篇&amp;amp&semi;下拉弹出列表选择项效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下拉弹出列表选择项效果 右边菜单中的按键,点击弹出一个列表可选择,选择其中一个,响应相应的事件并把文字显示在右边的菜单上:弹出下拉效果使用LMDropdownView插件,可以用POD进行加载pod ‘LMDropdownView’:LMDropdownView是把想要的视图赋给它: 源代码地址:https://github.com/JxbSir/YiYuanYunGou 效果如下: 1:在主页面先定义按键跟绑定视图(没写全的都是属性中定义了比如btnRigth,dropdownView等):			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QGqwB0.html" rel="bookmark">iOS开发之--全局解决模态弹出不全屏展示问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用tuntime的特性,创建一个UIViewController的类别,然后再pch文件里面调用即可,代码如下: .h #import &lt;UIKit/UIKit.h&gt; NS_ASSUME_NONNULL_BEGIN @interface UIViewController (SKPVCModel) @end NS_ASSUME_NONNULL_END .m #import &quot;UIViewController+SKPVCModel.h&quot; #import &lt;objc/ru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bLnVp4.html" rel="bookmark">IOS开发之自定义系统弹出键盘上方的view</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IOS开发之自定义系统弹出键盘上方的view 分类: IOS 2014-11-18 09:26 1304人阅读 评论(0) 收藏 举报 目录(?)[+] 这篇文章解决的一个开发中的实际问题就是:当弹出键盘时,自定义键盘上方的view.目前就我的经验来看,有两种解决方法.一个就是利用 UITextField或者UITextView的inputAccessoryView属性,另一种,就是监听键盘弹出的notification来自 己解决相关视图的位置问题. 第一种解决方法相对比较简单,第二种的方法中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyK7jE3.html" rel="bookmark">如何实现android蓝牙开发 自动配对连接&comma;并不弹出提示框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何实现android蓝牙开发 自动配对连接,并不弹出提示框 之前做一个android版的蓝牙,遇到最大的难题就是自动配对. 上网查资料说是用反射createBond()和setPin(),但测试时进行配对还是会出现提示,但配对是成功了 我就开始查找怎么关闭这个蓝牙配对提示框,后面还是伟大的android源码帮助了我. 在源码 BluetoothDevice 类中还有两个隐藏方法 cancelBondProcess()和cancelPairingUserInput() 这两个方法一个是取消配对进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rOozb4.html" rel="bookmark">系统弹出框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 /** 2 * 系统弹出框 3 */ 4 sAlert: function(tit,str,conf){ 5 if(document.getElementById(&quot;bgDiv&quot;)!=null){ 6 return; 7 } 8 var sWidth = document.body.offsetWidth; 9 var sHeight = document.body.scrollHeight; 10 var bgObj = document.createElement(&quot;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQlDL3.html" rel="bookmark" class="title">Java篇&colon;File类的基本API</a>
					<div>
						1 package ares.io; 2 3 import java.io.File; 4 import java.io.IOException; 5 6 public class Main { 7  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmR5v4.html" rel="bookmark" class="title">Java8的新特性</a>
					<div>
						Java 8主要新特性包括如下几点: 一.接口的默认方法和静态方法 Java 8版之前,接口只有抽象方法,而在Java 8,为接口新增了两种类型的方法. 第一种是默认方法:在Java 8中,可以通过使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68QVy3.html" rel="bookmark" class="title">FusionCharts simple demo for &lpar;html&plus;js、APS&period;NET Webform、MVC&rpar;</a>
					<div>
						做GIS或其他内部数据统计项目的应该对FusionCharts也不会太陌生,简单易用已无需多说什么了,只是有时候框架不同,实现起来也稍有差异 引用dll调用FusionCharts类的静态方法Rend ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vv5YZ3.html" rel="bookmark" class="title">Java HttpClient库的使用</a>
					<div>
						(一)简介 HttpClient是Apache的一个开源库,相比于JDK自带的URLConnection等,使用起来更灵活方便. 使用方法可以大致分为如下八步曲: 1.创建一个HttpClient对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjlen0.html" rel="bookmark" class="title">Oracle 的for update行锁</a>
					<div>
						SELECT...FOR UPDATE 语句的语法如下: SELECT ... FOR UPDATE [OF column_list][WAIT n|NOWAIT][SKIP LOCKED]; 其中: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg52EN3.html" rel="bookmark" class="title">C&plus;&plus;编程-&amp;gt&semi;pair（对组）</a>
					<div>
						pair 是 一种模版类型.每个pair 可以存储两个值.这两种值无限制,可以是tuple,vector ,string,struct等等. 首先来看一下pair的函数 初始化,复制等相关操作如下:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kql9K4.html" rel="bookmark" class="title">阿里云云服务器CentOS上安装Apache</a>
					<div>
						云服务器操作系统:CentOS 6.2 64位 客户端操作环境:Putty 操作步骤: 1. 运行 Putty,输入用户名,然后输入密码. 2. 安装 Apache 软件:yum install ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkng94.html" rel="bookmark" class="title">软件工程概论课个人总结</a>
					<div>
						在这一学期经历了16周的软件工程概论课程的学习,我学习到了很多知识,收获了很多,大二我们进入软件工程专业,对软件工程专业和所要学习的知识和方向还不了解,软件工程概论课向我们讲解了软件工程的基本概念和软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqz8oM.html" rel="bookmark" class="title">Java小游戏之打飞机&lpar;二&rpar;</a>
					<div>
						这篇文章本应昨天写的,可是真打算写的时候,CSDN博客维护,导致拖到了今天: 在上篇文章Java小游戏之打飞机(一)中已经详细介绍了该游戏的基本架构和需求分析,今天就详细写一写具体每个类的实现: 1) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRRmG4.html" rel="bookmark" class="title">python 正则分析nginx日志</a>
					<div>
						有个需求要分析nginx日志,也懒得去研究logstach之类的开源工具,干脆直接写一个脚本,自己根据需求来实现: 先看日志格式:我们跟别人的不太一样,所以没办法了: 12.195.166.35 [1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqlKQ4.html" rel="bookmark" class="title">选择用户-保存已选用户</a>
					<div>
						1介绍 功能要求: 1 选择用户界面以弹出框方式显示 2 页面选项动态加载(部门及用户) 3 保存勾选的用户 实现分析: 保存已选用户逻辑: 删除原来已选择的用户记录列表(相当于清空操作) 添加新选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyJ7w3.html" rel="bookmark" class="title">常用的网站站长SEO工具</a>
					<div>
						网站管理员工具 网站管理员工具需要对网站域名所有权进行验证,通常是通过上传指定文件.增加META或者修改网站DNS来验证管理员身份,通过验证后,网站管理员可以查询到自己网站的各类统计信息. 1. Go ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Opq1Z4.html" rel="bookmark" class="title">hdu 5780 gcd</a>
					<div>
						题意:给定$x, n$满足$1 \leq x, n \leq 1000000$,求$\sum{(x^a-1,x^b-1)}$对$1e9+7$取模后的值,其中$1 \leq a, b \leq n$.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpKaZ4.html" rel="bookmark" class="title">在linux中搭建git服务器</a>
					<div>
						个人觉得, 以下搭建git服务器的过程就像是在linux增加了一个用户, 而这个用户的登录shell是 git-shell, 太刨根问底的东西我也说不清楚, 还是看下面的过程吧. 过程参考了网上的文章 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDjqaM.html" rel="bookmark" class="title">针对此次iTunes12&period;1升级导致第三方用不了的解决方案</a>
					<div>
						事情起因我就不多说了 正如网络新闻报道所说 引用CSDN业界资讯: 由于,iTunes经过升级后,由32位替换成了64位的系统,两者在软件的兼容上,运算的处理上,都有了较大的不同,直接导致了多个苹果助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rDE7vM.html" rel="bookmark" class="title">【&period;net 深呼吸】自定义应用程序配置节</a>
					<div>
						实际上,应用程序配置文件 App.config,是由各个节(Configuration Section)组成的,通常,配置节是按功能划分的,比如我们很熟悉的 appSettings.connectio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rp2KvM.html" rel="bookmark" class="title">迷你MVVM框架 avalonjs 学习教程6、插入移除处理</a>
					<div>
						ms-if是属于流程绑定的一种,如果表达式为真值那么就将当前元素输出页面,不是就将它移出DOM树.它的效果与上一章节的ms-visible效果看起来相似的,但它会影响到:empty伪类,并能更节约性能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGLPnQ0.html" rel="bookmark" class="title">login shell 和 non-login shell 的相关问题</a>
					<div>
						问题:通过su命令切换用户并没有进入该用户的shell环境.这是为什么? 要解决这个问题,我们必须清楚用login shell 和non-login shell的区别. login shell:去的b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBKqWq0.html" rel="bookmark" class="title">Localhost 回环IP 127&period;0&period;0&period;1</a>
					<div>
						LocalHost 127.0.0.1是一个保留地址,用于本地软件测试以及本地进程间通信, 也叫回环IP.回环地址.回送地址(loopback address).无论什么程序,一旦使 用回环IP发送数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rp6daM.html" rel="bookmark" class="title">Linux信号量</a>
					<div>
						sem_init的应用 (1)信号量用sem_init函数创建的,下面是它的说明: #include&lt;semaphore.h&gt; int sem_init (sem_t *sem, int  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
